unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles;

const
  FORM_WIDTH_SET       = 480;
  FORM_HEIGHT_SET      = 260;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ButtonJumpFolder: TButton;
    ButtonList: TButton;
    ButtonStart: TButton;
    ButtonStop: TButton;
    Timer1: TTimer;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure ButtonJumpFolderClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    StrFormState: String;
    StrListWindowName: TStringList;
    StrListWindowHwnd: TStringList;
    StrListDone: TStringList;
    IntFormShift: Integer;
    IntGetInterval: Integer;

  public
    { Public 錾 }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

//WindowsAPIR[obN֐ EBhE̗
function EnumWindowsProc(Wnd: HWND; lParam: Longint): Bool; stdcall; export;
var
  szCaption: array [0..255] of Char;
begin
  //ݒ
  Result:= TRUE;
  //EBhEnh擾
  GetWindowText(Wnd, szCaption, sizeof(szCaption));

  //SΏ
  FormMain.StrListWindowName.Add(StrPas(szCaption));
  FormMain.StrListWindowHwnd.Add(IntToStr(Wnd));
end;

procedure TFormMain.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //m
  StrListWindowName := TStringList.Create;
  StrListWindowHwnd := TStringList.Create;
  StrListDone       := TStringList.Create;

  //
  Timer1.Enabled := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormMain', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormMain', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormMain', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormMain', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormMain', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  IntFormShift   := IniFile.ReadInteger('FormShiftJumpFolder', 'Value',    30);
  IntGetInterval := IniFile.ReadInteger('GetInterval',         'Value',  1000);
  //ۑ
  IniFile.WriteInteger('FormShiftJumpFolder', 'Value',    IntFormShift);
  IniFile.WriteInteger('GetInterval',         'Value',  IntGetInterval);
  //j
  IniFile.Free;

  //ݒ
  ButtonList.Enabled       := TRUE;
  ButtonJumpFolder.Enabled := TRUE;
  ButtonStart.Enabled      := TRUE;
  ButtonStop.Enabled       := FALSE;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormMain', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormMain', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormMain', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormMain', 'Left',   FormMain.Left);
    IniFile.WriteInteger('FormMain', 'Top',    FormMain.Top);
    IniFile.WriteInteger('FormMain', 'Width',  FormMain.Width);
    IniFile.WriteInteger('FormMain', 'Height', FormMain.Height);
  end;
  //j
  IniFile.Free;

  //j
  StrListWindowName.Free;
  StrListWindowHwnd.Free;
  StrListDone.Free;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  ListBox1.Height := (Formmain.ClientHeight - Panel1.ClientHeight) div 2;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormMain.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormMain.SetBounds(FORM_LEFT_SHIFT, FORM_TOP_SHIFT, FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormMain.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormMain.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //ꗗ擾
  ButtonListClick(Sender);

  //tH[JXݒ
  if listBox2.Items.Count = 0 then
  begin
    ButtonList.SetFocus
  end
  else
  begin
    ButtonJumpFolder.SetFocus
  end;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  iPos1: Integer;
  iPos2: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iFind1: Integer;
  bResult1: Boolean;
  bResult2: Boolean;
  WindowRect: TRect;
begin
  //ꗗ擾
  ButtonListClick(Sender);

  //s
  if ListBox2.Items.Count > 0 then
  begin
    //s
    for iRow1 := 0 to ListBox2.Items.Count-1 do
    begin
      //擾
      sStr1 := ListBox2.Items.Strings[iRow1];
      //enh
      iPos1 := Pos(' : ', sStr1);
      sStr4 := Copy(sStr1, 1, iPos1-1);
      sStr2 := Copy(sStr1, iPos1 + Length(' : '), Length(sStr1));
      //qnh
      iPos2 := Pos(' : ', sStr2);
      sStr3 := Copy(sStr2, 1, iPos2-1);

      //
      iFind1 := -1;
      for iRow2 := 0 to StrListDone.Count-1 do
      begin
        //ړς
        if sStr3 =StrListDone.Strings[iRow2] then
        begin
          iFind1 := iRow2;
          Break;
        end;
      end;

      //ړĂȂ
      if iFind1 = -1 then
      begin
        //擾
        bResult1 := GetWindowRect(StrToInt(sStr4), WindowRect);
        //
        if bResult1 = TRUE then
        begin
          //Handle, X, Y, Width, Height, Repaint
          bResult2 := MoveWindow(StrToInt(sStr3),
                                WindowRect.Left   + IntFormShift,
                                WindowRect.Top    + IntFormShift,
                                WindowRect.Width  - (IntFormShift * 2),
                                WindowRect.Height - (IntFormShift * 2),
                                TRUE);
          //
          if bResult2 = TRUE then
          begin
            //ړɒǉ
            StrListDone.Add(sStr3);
          end;
        end;
      end;
    end;
  end;
end;

procedure TFormMain.ButtonListClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  iPos1: Integer;
  iPos2: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iFind1: Integer;
  hwnd1: HWND;
begin
  //NA
  StrListWindowName.Clear;
  StrListWindowHwnd.Clear;
  ListBox1.Items.Clear;
  ListBox2.Items.Clear;
  ListBox1.Sorted := TRUE;
  ListBox2.Sorted := TRUE;

  //擾
  EnumWindows(@EnumWindowsProc, 0);
  //
  for iRow1 := 0 to StrListWindowName.Count-1 do
  begin
    if Pos(UpperCase('- WinFM2008'), UpperCase(StrListWindowName.Strings[iRow1])) > 0 then
    begin
      //ݒ
      ListBox1.Items.Add(StrListWindowHwnd.Strings[iRow1] + ' : ' +
                         StrListWindowName.Strings[iRow1]);
    end;
    if Pos(UpperCase('JumpFolder'), UpperCase(StrListWindowName.Strings[iRow1])) > 0 then
    begin
      //e擾
      hwnd1 := GetWindow(StrToInt(StrListWindowHwnd.Strings[iRow1]), GW_OWNER);
      //ݒ
      ListBox2.Items.Add(IntToStr(hwnd1)                  + ' : ' +   //enh
                         StrListWindowHwnd.Strings[iRow1] + ' : ' +   //qnh
                         StrListWindowName.Strings[iRow1]);
    end;
  end;
  //ݒ
  if ListBox1.Items.Count > 0 then
  begin
    //ݒ
    ListBox1.ItemIndex := 0;
  end;
  if ListBox2.Items.Count > 0 then
  begin
    //ݒ
    ListBox2.ItemIndex := 0;

    //
    for iRow1 := StrListDone.Count-1 downto 0 do
    begin
      //
      iFind1 := -1;
      for iRow2 := 0 to ListBox2.Items.Count-1 do
      begin
        //擾
        sStr1 := ListBox2.Items.Strings[iRow2];
        //enh
        iPos1 := Pos(' : ', sStr1);
        sStr2 := Copy(sStr1, iPos1 + Length(' : '), Length(sStr1));
        //qnh
        iPos2 := Pos(' : ', sStr2);
        sStr3 := Copy(sStr2, 1, iPos2-1);

        //
        if sStr3 = StrListDone.Strings[iRow1] then
        begin
          iFind1 := iRow2;
          Break;
        end;
      end;
      //Ȃ΁AʂȂ̂ŁAXg폜
      if iFind1 = -1 then
      begin
        StrListDone.Delete(iRow1);
      end;
    end;
  end;
end;

procedure TFormMain.ButtonJumpFolderClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  iPos1: Integer;
  iPos2: Integer;
  bResult1: Boolean;
  bResult2: Boolean;
  IniFile: TIniFile;
  WindowRect: TRect;
begin
  //s
  if (ListBox2.Items.Count > 0) and (ListBox2.ItemIndex >= 0) then
  begin
    //m
    IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
    //Ǎ
    IntFormShift   := IniFile.ReadInteger('FormShiftJumpFolder', 'Value',    30);
    //j
    IniFile.Free;

    //擾
    sStr1 := ListBox2.Items.Strings[ListBox2.ItemIndex];
    //enh
    iPos1 := Pos(' : ', sStr1);
    sStr4 := Copy(sStr1, 1, iPos1-1);
    sStr2 := Copy(sStr1, iPos1 + Length(' : '), Length(sStr1));
    //qnh
    iPos2 := Pos(' : ', sStr2);
    sStr3 := Copy(sStr2, 1, iPos2-1);

    //擾
    bResult1 := GetWindowRect(StrToInt(sStr4), WindowRect);
    //
    if bResult1 = TRUE then
    begin
      //Handle, X, Y, Width, Height, Repaint
      bResult2 := MoveWindow(StrToInt(sStr3),
                            WindowRect.Left   + IntFormShift,
                            WindowRect.Top    + IntFormShift,
                            WindowRect.Width  - (IntFormShift * 2),
                            WindowRect.Height - (IntFormShift * 2),
                            TRUE);
      //
      if bResult2 = TRUE then
      begin
        ;
      end;
    end;
  end
  else
  begin
    showmessage('JumpFolder ʂ܂');
  end;
end;

procedure TFormMain.ButtonStartClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //Ǎ
  IntGetInterval := IniFile.ReadInteger('GetInterval',         'Value',  1000);
  //j
  IniFile.Free;

  //Jn
  Timer1.Interval := IntGetInterval;
  Timer1.Enabled  := TRUE;
  StrListdone.Clear;
  //ݒ
  ButtonList.Enabled       := FALSE;
  ButtonJumpFolder.Enabled := FALSE;
  ButtonStart.Enabled      := FALSE;
  ButtonStop.Enabled       := TRUE;
  ButtonStop.SetFocus;
end;

procedure TFormMain.ButtonStopClick(Sender: TObject);
begin
  //~
  Timer1.Enabled  := FALSE;
  //ݒ
  ButtonList.Enabled       := TRUE;
  ButtonJumpFolder.Enabled := TRUE;
  ButtonStart.Enabled      := TRUE;
  ButtonStop.Enabled       := FALSE;
  ButtonStart.SetFocus;
end;

end.
